//
// maindlg.cpp
//
// Copyright (c) Alessandro Iacopetti , 1995. All Rights Reserved.
//

#include "stdafx.h"
#include "sfondo.h"
#include "maindlg.h"
#include "aboutdlg.h"
#include "zsupport.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

#define IDM_CAMBIA	100
extern CsfondoApp theApp;
char* CMainDialog::filename = "LoSfondo.txt";

// This is a specially modified modeless dialog box application class

//
// class CMainDialog
//

CMainDialog::CMainDialog(CWnd* pParent)
	: CDialog(CMainDialog::IDD, pParent)

{
	VERIFY(GetCurrentDirectory(MAX_PATH, m_currentdir));
	//{{AFX_DATA_INIT(CMainDialog)
	m_minuti		= 30;
	//m_cambiaflag		 = TRUE;
	//}}AFX_DATA_INIT
	m_timerid		= 0;

	Create(CMainDialog::IDD, pParent);
}

void CMainDialog::PostNcDestroy()
{
	delete this;
}

void CMainDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMainDialog)
	DDX_Control(pDX, IDC_LISTBOX1, m_lista);
	DDX_Text(pDX, IDC_MINUTI, m_minuti);
	DDV_MinMaxUInt(pDX, m_minuti, 1, 3600);
	DDX_Control(pDX, IDC_CAMBIAPERIODO, m_cambiaperiodo);
	//DDX_Check(pDX, IDC_CAMBIAPERIODO, m_cambiaflag);
	DDX_Control(pDX, IDC_MINUTI, m_minutiedit);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMainDialog, CDialog)
	//{{AFX_MSG_MAP(CMainDialog)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDABOUT, OnClickedAbout)
	ON_BN_CLICKED(IDC_CAMBIAPERIODO,OnClickedCambiaperiodo)
	ON_BN_CLICKED(IDC_AGGIUNGI,OnClickedAggiungi)
	ON_BN_CLICKED(IDC_ELIMINA,OnClickedElimina)
	ON_LBN_DBLCLK(IDC_LISTBOX1,OnDblclkListbox1)
	ON_WM_TIMER()
	ON_WM_SYSCOMMAND()
	ON_WM_QUERYENDSESSION()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

//
// CMainDialog commands
//


BOOL CMainDialog::OnInitDialog()
{
	CDialog::OnInitDialog();

	char buffer[MAX_PATH + 1];
	SetCurrentDirectory(m_currentdir);
	CStdioFile file;
	VERIFY(file.Open(filename, CFile::modeRead | CFile::typeText));
	file.ReadString(buffer, MAX_PATH);
	sscanf(buffer, "%d", &m_minuti);
	file.ReadString(buffer, MAX_PATH);
	int len;
	sscanf(buffer, "%d", &len);
	for (int i = 0; i < len; ++i) {
		file.ReadString(buffer, MAX_PATH);

		for (int j = 0; buffer[j]; ++j)
			if (buffer[j] == '\n')
				buffer[j] = 0;

		m_lista.AddString(buffer);
	}
	file.Close();

	if (m_minuti) {
		m_cambiaflag = 1;
		UpdateData(FALSE);
		m_timerid = SetTimer(1, 1000 * 60 * m_minuti, NULL);
	}
	else
		m_cambiaflag = 0;
	m_cambiaperiodo.SetCheck(m_cambiaflag);
	OnClickedCambiaperiodo();

	CMenu* sysmenu = GetSystemMenu(FALSE);
	sysmenu->AppendMenu(MF_SEPARATOR);
	sysmenu->AppendMenu(MF_STRING, IDM_CAMBIA, "Change");
	SetClassLong(GetSafeHwnd(), GCL_HICON, (LONG)theApp.LoadIcon(IDC_ICONDIALOGAPP));
	CenterWindow();
	ShowWindow(len ? SW_MINIMIZE : SW_SHOWNORMAL);

	srand(GetTickCount());
	if (len)
		SetWallpaper(rand() % m_lista.GetCount());

	return TRUE;
}

void CMainDialog::OnDestroy()
{
	UpdateConfig();

	if (m_timerid)
		KillTimer(m_timerid);

	CDialog::OnDestroy();

	::PostQuitMessage(0);
}

void CMainDialog::OnOK()
{
	CDialog::OnOK();

	SendMessage(WM_SYSCOMMAND, SC_MINIMIZE, 0);

	if (m_timerid) {
		KillTimer(m_timerid);
		m_timerid = 0;
	}

	if (m_cambiaflag)
		m_timerid = SetTimer(1, 1000 * 60 * m_minuti, NULL);
}

void CMainDialog::OnCancel()
{
	// Do not delete this call, the app needs to be destroyed
	DestroyWindow();
}

void CMainDialog::OnClickedAbout()
{
	CAboutDlg	about;

	about.DoModal();
}

void CMainDialog::OnClickedCambiaperiodo()
{
	m_cambiaflag = m_cambiaperiodo.GetCheck();
	m_minutiedit.EnableWindow(m_cambiaflag);
}


void CMainDialog::OnClickedAggiungi()
{
	CFileDialog dlg(TRUE, NULL, NULL, OFN_FILEMUSTEXIST | OFN_HIDEREADONLY, "Pictures|*.bmp;*.bmz;*.bmp.gz||", this);

	if (dlg.DoModal() == IDOK) {
		m_lista.AddString(dlg.m_ofn.lpstrFile);
	}

	GetDlgItem(IDOK)->SetFocus();
}


void CMainDialog::OnClickedElimina()
{
	int selcount = m_lista.GetSelCount();

	if (selcount > 0) {
		int* sel = new int[selcount];

		m_lista.GetSelItems(selcount, sel);
		for (int i = 0; i < selcount; ++i)
			m_lista.DeleteString(sel[selcount - i - 1]);

		delete []sel;
	}
}


void CMainDialog::OnDblclkListbox1()
{
	SetWallpaper(m_lista.GetCurSel());
}


void CMainDialog::SetWallpaper(int i)

{
	int len = m_lista.GetTextLen(i);
	char* str = new char[len + 1];
	m_lista.GetText(i, str);

	if (((len > 4) && (strcmpi(&str[len - 4], ".bmz") == 0)) || ((len > 7) && (strcmpi(&str[len - 7], ".bmp.gz") == 0))) {
		char tempname[MAX_PATH];
		GetTempPath(MAX_PATH, tempname);
		strcat(tempname, "\\LoSfondo.bmp");

		if (file_uncompress(str, tempname))
			SystemParametersInfo(SPI_SETDESKWALLPAPER, NULL, tempname, SPIF_UPDATEINIFILE);
		else
			AfxMessageBox("Errore nel file compresso");
	}
	else
		SystemParametersInfo(SPI_SETDESKWALLPAPER, NULL, str, SPIF_UPDATEINIFILE);

	delete []str;
}

void CMainDialog::OnTimer(UINT nIDEvent)
{
	SetWallpaper(rand() % m_lista.GetCount());

	CDialog::OnTimer(nIDEvent);
}


void CMainDialog::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID == IDM_CAMBIA) && (m_lista.GetCount()))
		SetWallpaper(rand() % m_lista.GetCount());

	CDialog::OnSysCommand(nID, lParam);
}


BOOL CMainDialog::OnQueryEndSession()
{
    UpdateConfig();

    if (!CDialog::OnQueryEndSession())
        return FALSE;

    return TRUE;
}


void CMainDialog::UpdateConfig()

{
	UpdateData(TRUE);

	char buffer[MAX_PATH + 1];
	SetCurrentDirectory(m_currentdir);
	CStdioFile file;
	VERIFY(file.Open(filename, CFile::modeWrite | CFile::modeCreate | CFile::typeText));
	if (m_cambiaflag)
		wsprintf(buffer, "%d\n", m_minuti);
	else
		wsprintf(buffer, "0\n");
	file.WriteString(buffer);
	wsprintf(buffer, "%d\n", m_lista.GetCount());
	file.WriteString(buffer);
	for (int i = 0; i < m_lista.GetCount(); ++i) {
		m_lista.GetText(i, buffer);
		file.WriteString(buffer);
		file.WriteString("\n");
    }
	file.Close();
}
